// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: AVR_api.c
* - ߲		: IAR EWAAVR 4.11a
*
* - xҰ		: avr@atmel.com
*
* - x޲	: UART/USARTS޲gpł܂B
*				  ATmega128pɏĂ܂B
*
* - pLq	: AVR323 - GSMϕ̲̪
*
* - 		: GSMϕ퐧̂߂AT()gp@̗
*
* $Revision: 1.1 $
* $Date: Tuesday, November 08, 2005 12:25:34 UTC $
*****************************************************************************/

// ݸٰ
#include"AVRGSM_zip.h"

//! ׯ ؒ萔
const unsigned char __flash hex_lookup[]	= hex_nmbr;				//!< 16ipQƕ\
const unsigned char __flash mask[7]			= {1,3,7,15,31,63,127};	//!< ՕlpQƕ\
const unsigned char __flash power[7]		= {128,64,32,16,8,4,2};	//!< 2ׂ̂pQƕ\

/*! \brief gpҒ`̕PDU`Ɏ荞݂܂B
 *
 * \param	*in			gpҒ`ւ̈ʒuwq
 * \param	*discarded	үޒvZɎgpj
 * \param	ret[]		үޗp̕Ԃz
 *
 * \retval	i			ǂݍݕ
 *
 */
int ZIP_compress( unsigned char *in, unsigned char *discarded, unsigned char ret[] )
{
	//! Ǐϐ
	int i,ii,iii;
	unsigned char encode_c, now_c, next_c;

	*discarded = 0;															// 
	for( i = ii = iii = 0; ( in[i] != '\0' ) && ( i < MESSAGE_LENGTH ); )	// Ŝʂđs
	{
		now_c = in[ i++ ];													// 񕶎擾
		next_c = in[ i ];													// 擾
		if( next_c == '\0' )												// 0(Iq)
		{
			next_c = 0;														// ɏIݒ
		}
		encode_c = ( now_c >> ii )+ ( mask[ ii ] & next_c )*power[ ii ];	// 
		ret[ iii++ ] = hex_lookup[ ( encode_c >> 4 ) & 0x0F ];				// 摤16iۑ
		ret[ iii++ ] = hex_lookup[ ( encode_c & 0x0F ) ];					// 㑤16iۑ
		if( ii == 6 )														// 7ޯĕŁA
		{
			ii = 0;															// ޯĈʒuv평
			i++;															// ʒuwqis
			(*discarded)++;													// jis
		}
		else																// 0`6ޯĕŁA
		{
			ii++;															// ޯĈʒuvis
		}
	}
	ret[iii] = '\0';														// zIqݒ
	return i;																// ƋɕA
}

/*! \brief PDU`̕үނǕɈk܂B
 *
 * \param	*compressed		PDU
 * \param	*decompressed	Ԃzւ̈ʒuwq
 *
 * \retval	iii				
 */
int ZIP_decompress( unsigned char *compressed, unsigned char *decompressed )
{
	//! Ǐϐ
	int i,ii,iii;															// wW
	unsigned char rest_c, ans_c ,dec_c , this_c, next_c;					// ǂݍݒlƈꎞl̕ϐ

	for( i = ii = iii = rest_c = 0; (this_c = compressed[i++]) != '\0'; )	// Ŝʂđs
	{
		next_c = compressed[i++];											// AVR_SMS_com.c̊ɏՕǂݍ
		// ϊ
		dec_c = 16 * ZIP_htoi( this_c ) + ZIP_htoi( next_c );				// 210il擾
		ans_c = dec_c & mask[6 - ii];										// ΉޯĂ̂ݗL
		ans_c <<= ii;														// ΉޯĈʒuֈړ
		decompressed[iii++] = ans_c + rest_c;								// 񈳏kl擾/ۑ
		rest_c = (dec_c & ~mask[6 - ii]) >> ( 7 - ii );						// pcޯĒl擾
		if( ii == 6)														// 7ޯĕŁA
		{
			ii = 0;															// ޯĈʒuv평
			decompressed[ iii++ ] = rest_c;									// kl擾/ۑ
			rest_c = 0;														// pcޯĒl
		}
		else																// 0`6ޯĕŁA
		{
			ii++;															// ޯĈʒuvis
		}
	}
	decompressed[ iii ] = '\0';												// ԂzIqݒ
	return iii;																// ƋɕA
}

/*! \brief ASCII𐮐^ɕϊ
 *
 * \note	^ƂĒlԂ܂B
 *
 * \param	*a	ϊׂASCII
 * \param	n	Ԃ鐮^
 *
 * \retval	int	l
 */
int ZIP_atoi( unsigned char *a )
{
	int i, n;												// ƕϐ

	n = 0;													// 
	for( i=0; ( a[ i ] >= '0' ) && ( a[ i ] <= '9' ); ++i )	// ASCII琮֕ʂđs
	{
		n = 10*n + ( a[ i ] - '0' );						// ԂɍlZ
	}
	return n;												// lƋɕA
}

/*! \brief 16i𐮐֕ϊ
 *
 * ̊֐͕`16iloĂ̐lԂ܂B
 *
 * \param	hex	ϊ16il
 *
 * \retval	int	16l̐\
 */
int ZIP_htoi( unsigned char hex )
{
	if( ( hex >= 'A' ) && ( hex <= 'F' ) )	// 'A'`'F'ŁA
	{
		return hex - 'A' + 10;				// 10`15̐lƋɕA
	}
	else									// 'A'`'F'ȊOŁA(:'0'`'9'łȂ΂Ȃ܂B)
	{
		return hex - '0';					// 0`9̐lƋɕA
	}
}

/*! \brief 0`255̐16ilɕϊ
 *
 * \note	Ƃ16ilԂ܂B
 *
 * \param	n	ׂl
 * \param	ret	Ԃz
 *
 */
void ZIP_itoh( int n, unsigned char *ret )
{
	ret[ 0 ] = hex_lookup[ ( n >> 4 ) & 0x0F ];	// 16iʌϊ/ݒ
	ret[ 1 ] = hex_lookup[ ( n & 0x0F ) ];		// 16iʌϊ/ݒ
	ret[ 2 ] = '\0';							// zɏIqݒ
}
